<?php
namespace Modules\Parametros\Services;

class GQL01600ParametrosGestaoQualificacaoService
{
    protected $connection;
    
    public function __construct($entityManager, $environment)
    {
        $this->connection  = $entityManager->getConnection();
        $this->environment = $environment;
    }
    
    /*************
     * Tab Geral *
     *************/
    
    public function findGrupoOperadorCadastrado()
    {
        try {
            $query = "SELECT
                          GRUPOPER.CDGRUPOPER,
                          GRUPOPER.DSGRUPOPER
                        FROM AUTGRUPOP, GRUPOPER
                        WHERE AUTGRUPOP.CDGRUPOPER = GRUPOPER.CDGRUPOPER
                          AND AUTGRUPOP.IDAUTGRUPOP = 'PAOC'
                          AND AUTGRUPOP.NRAUTGRUPOP = '000'";
            
            $std = $this->connection->prepare($query);
            $std->execute([]);
            
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function insertGrupoOco($row)
    {
        try {
            $param = array(
    		    'CDGRUPOPER' => $row['CDGRUPOPER'],
    		);
    		
            $query = "INSERT INTO AUTGRUPOP
                           (CDGRUPOPER, IDAUTGRUPOP, NRAUTGRUPOP)
                    VALUES
                           (:CDGRUPOPER, 'PAOC', '000')";
            
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function deleteGrupoOcoAtual()
    {
        try {
            $query = "DELETE FROM AUTGRUPOP WHERE IDAUTGRUPOP = 'PAOC'";
            
            $std = $this->connection->prepare($query);
            $std->execute([]);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    /***************
     * Tab Unidade *
     ***************/
    
    public function acmUpdParamQualid($row)
    {
        try {
            $param = array(
    		    'OLD_CDFILIAL' => $row['CDFILIAL'],
    		    'CDFILIAL' => $row['CDFILIAL'],
    		    'IDINCOCORR' => $row['IDINCOCORR'],
    		    'IDAPURAUTQFO' => $row['IDAPURAUTQFO'],
    		    'IDEXIGEOCORPROD' => $row['IDEXIGEOCORPROD'],
    		    'NRORG' => $this->environment->getNrOrg(),
    		);
    		
            $query = "update PARAMFILIAL
                        set
                          CDFILIAL = :CDFILIAL,
                          IDINCOCORR = :IDINCOCORR,
                          IDAPURAUTQFO = :IDAPURAUTQFO,
                          IDEXIGEOCORPROD = :IDEXIGEOCORPROD
                        where
                          CDFILIAL = :OLD_CDFILIAL AND
                          NRORG = :NRORG";
            
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
}
